;------------------------------------------------------------------
; use "iglobal" for inserting initialized global data definitions.
;------------------------------------------------------------------
macro iglobal {
  IncludeIGlobals fix IncludeIGlobals,
  macro __IGlobalBlock {
}

;-------------------------------------------------------------
; use 'uglobal' for inserting uninitialized global definitions.
; even when you define some data values, these variables
; will be stored as uninitialized data.
;-------------------------------------------------------------
macro uglobal {
  IncludeUGlobals fix IncludeUGlobals,
  macro __UGlobalBlock {
}

endg fix }      ; Use endg for ending iglobal and uglobal blocks.

macro __IncludeIGlobals dummy,[n]
{
  forward
   __IGlobalBlock
   purge __IGlobalBlock
}

macro __IncludeUGlobals dummy,[n]
{
  common
    local begin, size
    begin = $
    virtual at $
  forward
      __UGlobalBlock
      purge __UGlobalBlock
  common
      size = $ - begin
    end virtual
    rb size
}

macro IncludeAllGlobals {
  local begin

  begin = $
  IncludeIGlobals

  begin = $
  IncludeUGlobals
}

IncludeIGlobals fix __IncludeIGlobals
IncludeUGlobals fix __IncludeUGlobals

iglobal
endg

uglobal
endg
