thread:
;        mcall   58, fileinfo
;        ; ebx = file size
;        shr     ebx, 9            ; division by 512 - size of block
;        mov     [file_size], ebx

;       mcall   40, 101b
        call    draw_window
        call    main_loop
        mov     [status], ST_EXIT
        mcall   -1

;---------------------------------------------------------------------

main_loop:
        call    draw_progress_bar
        mcall   23, 80
        cmp     eax, EV_REDRAW
        je      redraw
        cmp     eax, EV_BUTTON
        je      button
        cmp     eax, EV_KEY
        je      key
        jmp     main_loop

 redraw:
        call    draw_window
        jmp     main_loop

 key:
        mcall   2
        cmp     [textbox_active], 1
        jne     main_loop
        cmp     ah, 13
        je      .enter
        cmp     ah, 8
        je      .backspace
        movzx   ecx, [textbox_position]
        cmp     ecx, 47
        jae     .enter
        mov     [textbox_string + ecx], ah
        inc     [textbox_position]
        call    textbox_draw
        jmp     main_loop
  .enter:
        mov     [textbox_active], 0
        call    textbox_draw
        jmp     main_loop
  .backspace:
        movzx   ecx, [textbox_position]
        test    ecx, ecx
        jz      main_loop
        mov     [textbox_string + ecx], byte 0
        dec     [textbox_position]
        call    textbox_draw
        jmp     main_loop

 button:
        mcall   17
        cmp     ah, 0x10
        je      play_button
        cmp     ah, 0x11
        je      stop_button
        cmp     ah, 0x12
        je      decr_button
        cmp     ah, 0x13
        je      incr_button
        cmp     ah, 0x14
        je      volm_button
        cmp     ah, 0x15
        je      volp_button
        cmp     ah, 0x20
        je      activate_textbox
        cmp     ah, 1
        jne     main_loop
        ret
    play_button:
        mov     [status], ST_PLAY
        jmp     main_loop
    stop_button:
        mov     [status], ST_STOP
        jmp     main_loop
    decr_button:
        mov     eax, [fileinfo.first_block]
        cmp     eax, 1000
        jnl     @f
        mov     [fileinfo.first_block], 0
        jmp     main_loop
       @@:
        sub     [fileinfo.first_block], 1000
        jmp     main_loop
    incr_button:
        add     [fileinfo.first_block], 1000
        jmp     main_loop
    volm_button:
        inc     byte [volume]
        and     byte [volume], 0x1f
        jz      volp_button
        or      [volume], 0x10000000
        jmp     main_loop
    volp_button:
        dec     byte [volume]
        and     byte [volume], 0x1f
        jz      volm_button
        or      [volume], 0x10000000
        jmp     main_loop
    activate_textbox:
        cmp     [status], ST_DONE
        jne     main_loop
        mov     [textbox_active], 1
        call    textbox_draw
        jmp     main_loop
ret

;---------------------------------------------------------------------

draw_window:
        mcall   12, 1

        mpack   ebx, 100, 299
        mpack   ecx, 100, 71 ;57 ;44
        mov     edx, 0x03404040
        mcall   0

        mov     edi, 6
        mpack   ebx, 7, 45
        mpack   ecx, 24, 13
        mov     edx, 0x10
        mov     esi, 0xA0A0A0
      @@:
        mcall   8
        add     ebx, 48 shl 16
        inc     edx
        dec     edi
        jnz     @b

        mpack   ebx, 8, 8
        mcall   4, , 0x10FFFFFF, header, header.size

        mpack   ebx, 13, 28
        mov     edx, buttons_text
        mov     esi, buttons_text.size
        mov     ecx, 0x00404040
        mcall
        sub     ebx, 0x00010001
        mov     ecx, 0x00FFFFFF
        mcall

        call    draw_progress_bar
        call    textbox_draw

        mcall   12, 2
ret

;---------------------------------------------------------------------

textbox_draw:
        mpack   ebx, 7, 285
        mpack   ecx, 54, 10
        mov     edx, 0x40000020
        mcall   8

        mpack   ebx, 7, 286
        mpack   ecx, 54, 11
        mov     edx, 0x808080
        cmp     [textbox_active], 1
        jne     @f
        mov     edx, 0xA0A0A0
    @@:
        mcall   13

        mpack   ebx, 10, 55
        mov     ecx, 0x404040
        mov     edx, textbox_string
        movzx   esi, [textbox_position]
        mcall   4
ret

;---------------------------------------------------------------------

draw_progress_bar:
        pushad
        mov     eax, [fileinfo.first_block]
        imul    eax, 286
        xor     edx, edx
        div     [file_size]

        push    eax
        mpack   ebx, 7, 286
        mpack   ecx, 41, 10
        mov     edx, 0x808080
        mcall   13
        pop     eax

        mov     bx, ax
        mov     edx, 0xa0a0a0
        mcall   13

        popad
ret

;---------------------------------------------------------------------

sz header,       "AC'97 WAV player - 48KHz 16bit stereo"
sz buttons_text, " Play    Stop     <<      >>     Vol-    Vol+"

textbox_active    db 0
textbox_position  db textbox_string.size-1
file_size dd 100
